%define _without_online_tests 1
BuildRequires: /proc
BuildRequires: jpackage-1.4-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

# If you don't want to run the online tests
# give rpmbuild option '--without online_tests'

%define with_online_tests %{!?_without_online_tests:1}%{?_without_online_tests:0}
%define without_online_tests %{?_without_online_tests:1}%{!?_without_online_tests:0}

%define namedversion    1.0-incubating-SNAPSHOT
%define short_name      woden

Name:           ws-woden
Version:        1.0
Release:        alt1_0.m7a.1jpp1.7
Epoch:          0
Summary:        WSDL document library
License:        Apache Software License 2.0
Url:            http://jakarta.apache.org/httpcomponents/httpcore/
Group:          Development/Java
Source0:        http://people.apache.org/dist/ws/woden/milestones/1.0M7a-incubating/apache-woden-incubating-1.0M7a-src.tar.gz

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Patch0:         %{name}-pom_xml.patch
# patch these tests to delay between requests to dev.w3.org!!
Patch1:         %{name}-OMW3CTestSuiteTest.patch
Patch2:         %{name}-W3CTestSuiteTest.patch
Patch3:         %{name}-NoOnlineTests.patch


BuildRequires: jpackage-utils >= 0:1.7.2
BuildRequires: ant >= 0:1.6.5
BuildRequires: junit >= 0:3.8.2
%if %{with_maven}
BuildRequires: maven2-plugins >= 2.0.4-10jpp
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-install
BuildRequires: maven2-plugin-jar
BuildRequires: maven2-plugin-javadoc
BuildRequires: maven2-plugin-resources
BuildRequires: maven2-plugin-surefire
%endif
BuildRequires: bea-stax-api
BuildRequires: jakarta-commons-logging
BuildRequires: ws-commons-XmlSchema
BuildRequires: ws-commons-axiom
BuildRequires: wsdl4j
BuildRequires: wstx
BuildRequires: xerces-j2
BuildRequires: xml-commons-jaxp-1.3-apis
Requires: ant >= 0:1.6.5
Requires: bea-stax-api
Requires: ws-commons-XmlSchema
Requires: ws-commons-axiom
Requires: wsdl4j
Requires: wstx
Requires: xerces-j2
Requires: xml-commons-jaxp-1.3-apis


Requires(post): jpackage-utils >= 0:1.7.2
Requires(postun): jpackage-utils >= 0:1.7.2
%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%if ! %{gcj_support}
BuildArch:      noarch
%endif

%description
The Woden project is an incubation subproject of the Apache
Web Services Project to develop a Java class library for
reading, manipulating, creating and writing WSDL documents,
initially to support WSDL 2.0 but with the longer term aim
of supporting past, present and future versions of WSDL.

There are two main deliverables: an API and an implementation.
The Woden API will consist of a set of Java interfaces. The
WSDL 2.0-specific portion of the Woden API will conform to the
W3C WSDL 2.0 specification. The implementation will be a high
performance implementation directly usable in other Apache
projects such as Axis2.


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n woden-incubating-1.0M7a
cp %{SOURCE1} settings.xml
mkdir -p .m2/repository/JPP/maven2/default_poms/
%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%if ! %{with_online_tests}
%patch3 -b .noonline
%endif

%build
%if %{with_maven}
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

mvn-jpp \
-Dmaven.test.skip=true \        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.mode=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install javadoc:javadoc
%else
export CLASSPATH=$(build-classpath \
ws-commons-XmlSchema \
wsdl4j \
xerces-j2 \
xml-commons-jaxp-1.3-apis \
ws-commons-axiom-api \
ws-commons-axiom-impl \
wstx/wstx-asl \
bea-stax-api \
commons-logging \
junit \
)
ant -Dbuild.sysclasspath=only \
     buildImplAndAPI buildTests runTests buildJavadoc

%endif


%install
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
%if %{with_maven}
install -m 644 target/%{short_name}-%{namedversion}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%else
install -m 644 dist/%{name}-SNAPSHOT.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 dist/%{name}-SNAPSHOT.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-nio-%{version}.jar
%endif
%add_to_maven_depmap org.apache.woden woden %{namedversion} JPP %{name}

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)


# poms
%if %{with_maven}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom
%endif

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %{with_maven}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%else
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink


%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then 
  rm -f %{_javadocdir}/%{name}
fi

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap 
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif


%files
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%if %{with_maven}
%{_datadir}/maven2/poms/*
%endif
%{_mavendepmapfragdir}
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-*%{version}.jar.*
%endif

%files javadoc
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Wed Nov 28 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt1_0.m7a.1jpp1.7
- converted from JPackage by jppimport script

